Initial import of binutils 2.22 on the new vendor branch
[dragonfly.git] / contrib / cryptsetup / tests / align-test
1 #!/bin/bash
2
3 CRYPTSETUP="../src/cryptsetup"
4 DEV=""
5
6 cleanup() {
7         udevadm settle 2>/dev/null 2>&1
8         rmmod scsi_debug 2>/dev/null
9         sleep 2
10 }
11
12 fail()
13 {
14         [ -n "$1" ] && echo "$1"
15         cleanup
16         exit 100
17 }
18
19 add_device() {
20         modprobe scsi_debug $@
21         if [ $? -ne 0 ] ; then
22                 echo "This kernel seems to not support proper scsi_debug module, test skipped."
23                 exit 0
24         fi
25
26         sleep 2
27         DEV=$(grep scsi_debug /sys/block/*/device/model | cut -f4 -d /)
28
29         if [ ! -e /sys/block/$DEV/alignment_offset ] ; then
30                 echo "This kernel seems to not support topology info, test skipped."
31                 cleanup
32                 exit 0
33         fi
34
35         DEV="/dev/$DEV"
36         [ -b $DEV ] || fail "Cannot find $DEV."
37 }
38
39
40 format() # key_bits expected [forced]
41 {
42         if [ -z "$3" ] ; then
43                 echo -n "Formatting using topology info ($1 bits key)...."
44                 echo xxx| $CRYPTSETUP luksFormat $DEV -q -s $1
45         else
46                 echo -n "Formatting using forced offset $3 ($1 bits key)..."
47                 echo xxx| $CRYPTSETUP luksFormat $DEV -q -s $1 --align-payload=$2
48         fi
49
50         ALIGN=$($CRYPTSETUP luksDump $DEV |grep "Payload offset" | sed -e s/.*\\t//)
51         #echo "ALIGN = $ALIGN"
52
53         if [ $ALIGN -ne $2 ] ; then
54                 echo "FAIL"
55                 echo "Expected alignment differs: expected $2 != detected $ALIGN"
56                 fail
57         fi
58         echo "PASSED"
59 }
60
61 if [ $(id -u) != 0 ]; then
62         echo "WARNING: You must be root to run this test, test skipped."
63         exit 0
64 fi
65
66 modprobe --dry-run scsi_debug || exit 0
67 cleanup
68
69 echo "# Create desktop-class 4K drive"
70 echo "# (logical_block_size=512, physical_block_size=4096, alignment_offset=0)"
71 add_device dev_size_mb=16 sector_size=512 physblk_exp=3 num_tgts=1
72 format 256 2112
73 format 128 1088
74 format 256 8192 8192
75 format 128 8192 8192
76 cleanup
77
78 echo "# Create desktop-class 4K drive w/ 63-sector DOS partition compensation"
79 echo "# (logical_block_size=512, physical_block_size=4096, alignment_offset=3584)"
80 add_device dev_size_mb=16 sector_size=512 physblk_exp=3 lowest_aligned=7 num_tgts=1
81 format 256 2119
82 format 128 1095
83 cleanup
84
85 echo "# Create enterprise-class 4K drive"
86 echo "# (logical_block_size=4096, physical_block_size=4096, alignment_offset=0)"
87 add_device dev_size_mb=16 sector_size=4096 num_tgts=1
88 format 256 2560
89 format 128 1536 
90 cleanup
91
92 echo "# Create classic 512b drive and stack dm-linear"
93 echo "# (logical_block_size=512, physical_block_size=512, alignment_offset=0)"
94 add_device dev_size_mb=16 sector_size=512 num_tgts=1
95 DEV2=$DEV
96 DEV=/dev/mapper/luks0xbabe
97 dmsetup create luks0xbabe --table "0 32768 linear $DEV2 0"
98 format 256 2112
99 format 128 1088
100 format 128 8192 8192
101 dmsetup remove luks0xbabe
102 cleanup